/**
 * Colorful OTO Measure
 * 
 *          1 VDD        14 VSS
 * Sound    2 RA5        13 RA0 -
 * DO       3 RA4        12 RA1 -
 * -        4 RA3        11 RA2 -
 * LED Auto 5 RC5        10 RC0 SW Peak
 * LED Log  6 RC4         9 RC1 SW Mode
 * TX       7 RC3         8 RC2 SW Debug
 *  
 * PIC16F18325 MPLAB X IDE v5.40 with XC8 Ver2.05
 * (c)2022 Futoshi Sumikawa. 2022/08/01
 */

// -------------------------------------------------------------------------------------------------
//JtW[
//
//쐬:2022/08/01
//쐬:쑾u
//
//PDX^[gAbv
//
//@ݒ
//@
//@{^̏Ԃ`FbN
//@@i{^Ăꍇj
//@@@\tgEFAZbgsB
//@@@@mCY̊wKf[^ƓݒZbgB
//
//QDC[v
//
//@DebugXCb`̏Ԃ`FbN
//@@iDebugXCb`ON(Low)̏ꍇj
//@@@fobOp̒lVAŏo͂B
//
//RDC^[o^C}(10ms)̃Cxgnh̏
//
//@̌v
//@ADCŉvB
//@
//@LED\
//@ΐ\ON/OFFƃI[gWON/OFF\LED\B
//@
//@{^͏
//@iΐ\̃{^Ƃj
//@\ASYIB
//@ @0 : ΐ\iő僌Wj
//@ @1 : ΐ\iI[gWj
//@ @2 : jA\iő僌Wj
//@ @3 : jA\iI[gWj
//@ @4 : \iő僌Wj
//@
//@iΐ\̃{^𒷉Ƃj
//@Ot̕\IB
//@ @0 : ֕\
//@ @1 : ォ牺֕\
//@ @2 : 邳
//@
//@is[Nz[h̃{^Ƃj
//@s[Nz[h̕\IB
//@ @0 : s[Nz[hiʏj
//@ @1 : s[Nz[hij
//@ @2 : s[Nz[hȂ
//@
//@is[Nz[h̃{^𒷉Ƃj
//@@F̏͐F̏zIB
//@@ @0 : F̏
//@@ @1 : F̋t̏
//@@ @2 : F̏z
//@
//@ItZbgvZ
//@1bԊuŌvl̕ςvZăItZbgiM0_j߂B
//@
//@mCYo
//@vlumCỶ͂臒lv菬ԂumCỶ͂ێ鎞ԁv(10b)pƂɃmCYȏΏۂɂB
//@@@10bԂ́umCỶ͂臒lv܂ł̌vl̕zJEgB
//@@@(1)umCYƂăJbgMv̔
//@@@@vl̕zAvl̒ႢقZčsB
//@@@@Zlvl̑Ŝ̐(1000)́umCYƂăJbgM𔻒肷M̊v(95)܂œB
//@@@@̌vlumCYƂăJbgMvƔfB
//@@@(2)umCỶ͂臒lv̔
//@@@@vl̕zAvl̍ق`FbNB
//@@@@0ł͂ȂloǑvlɁumCỶ͂̂сv(4)ZlumCỶ͂臒lvƔfB
//@
//@mCYJbg
//@oumCYƂăJbgMv̒lɁumCŶсv(2)ZlN
//@@@umCYƂăJbgM̍őlv(16)𒴂ĂȂꍇ́A̒lNȉmCYƂăJbgB
//@@@lNumCYƂăJbgM̍őlv(16)𒴂Ăꍇ́umCYƂăJbgM̍őlv(16)ȉmCYƂăJbgB
//@
//@\ASY̌vZ
//@@
//@iI[gW̑ΐ\̏ꍇj
//@͂̍őlĎāAl݂̃W𒴂ƂɁA̒lŃOtőɂȂ悤ɃWグđΐ\B
//@@l݂̃W𒴂Ȃꍇ4bɃWŏɂđΐ\B
//@@
//@iő僌W̑ΐ\̏ꍇj
//@͂ő̎ɃOtőɂȂ悤ɑΐ\
//@@
//@iI[gW̃jA\̏ꍇj
//@͂̍őlĎāAl݂̃W𒴂ƂɁA̒lŃOtőɂȂ悤ɃWグăjA\B
//@@l݂̃W𒴂Ȃꍇ4bɃWŏɂđΐ\B
//@@
//@iő僌W̃jA\̏ꍇj
//@@͂ő̎ɃOtőɂȂ悤ɃjA\B
//@
//@Ot\
//@@IꂽF̏͐F̏zŒlOt\B
//@@@@s[Nz[hݒ肳Ăꍇ́AuԂ̍őlis[Njő僌W̐FŃOtɊ܂߂ĕ\B
//
// ------------------------------------------------------------------------------------------------- 


/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18325
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include "ws2812.h"

#define PIN_ANALOG_INPUT        0
#define PIN_LED_LOGARITHMIC     5
#define PIN_LED_AUTO_RANGE      6
#define PIN_BUTTON_MODE         7
#define PIN_BUTTON_PEAK_HOLD    8

#define EEPROM_INITIALIZE       0x7000
#define EEPROM_NOIZE_DEFAULT    0x7001
#define EEPROM_NOIZE_THRESHOLD  0x7002
#define EEPROM_MODE_ALGORITHM   0x7003
#define EEPROM_MODE_PEAK_HOLD   0x7004
#define EEPROM_MODE_DISPLAY     0x7005
#define EEPROM_MODE_REVERS      0x7006
#define EEPROM_BRIGHTNESS       0x7007

#define INITIALIZE_ID 0x41

// dADCl(1024 * 3300 / 4096 = 825)
#define ANALOG_3V3 825

// \_
#define NUMBER_OF_PIXELS 32

// x\鎞
#define TIMER_LEVEL 1
// s[Nz[h̎
#define TIMER_PEAK_HOLD 5
// I[gWێ鎞
#define TIMER_AUTO_RANGE 400
// mCỶ͂ێ鎞
#define TIMER_NOIZE_DETECTION 1000
// ItZbgvZ̃TvOvԁiP10msj(Ғl512100(x10ms)ȉz)
#define TIMER_ADC_OFFSET_CALCULATION 100
// 莞ԁiP10msj
#define TIMER_LONG_PRESS 100
// F̏z̎
#define TIMER_COLOR_CIRCULATION_INDEX 2
// vZ̃TvOvԁiP10msj
#define TIMER_SOUND_PRESURE 100


// mCYƂăJbgM𔻒肷M̊iő100()j
#define NOIZE_RATIO 95
// mCYƂăJbgM̏l
#define NOIZE_DEFAULT 4
// mCYƂăJbgM̍ől
#define NOIZE_MAX 16
// mCỶ͂臒l̏l
#define NOIZE_THRESHOLD_INITIAL_VALUE 32
// mCỶ͂̂
#define NOIZE_THRESHOLD_PLAY 4
// mCŶ
#define NOIZE_PLAY 2

// ΐ\W̉iADClj
#define RANGE_LOWER_BOUND 40

// 邳
#define BRIGHTNESS_DEFAULT 2
#define BRIGHTNESS_MIN 2
#define BRIGHTNESS_MAX 6

// o[X
#define DEFAULT_REVERS 1

// 
uint16_t _amplitude = 0;
uint16_t _measuredValue = 0;
uint16_t _adcOffset = 0;
uint16_t _adcOffsetCycle = 0;
uint16_t _sumMeasuredValue = 0;
uint16_t _detectedAmplitude = 0;

// vW
int16_t _range = 0;

// mCY
uint8_t __noize = NOIZE_DEFAULT;
uint8_t __noizeThreshold = NOIZE_THRESHOLD_INITIAL_VALUE;
uint16_t _noizeCycle = 0;
uint16_t _noizeValueTable[NOIZE_THRESHOLD_INITIAL_VALUE];
uint16_t _noizeValueUpThreshold = TIMER_NOIZE_DETECTION / 100 * NOIZE_RATIO;
uint16_t _noizeLevelLogarithm = 0;

// s[Nz[h
uint16_t _peakHoldTime = TIMER_PEAK_HOLD;

// ő僌W̑ΐl
uint16_t _maxRangeLogarithm = 0;

// {^ݒl
uint8_t __modeAlgorithm = 0;
uint8_t __modePeakHold = 0;
uint8_t __modeDisplay = 0;
uint8_t __isRevers = 0;
uint8_t _isLogarithmicMode = 1;
uint8_t _isAutoRangeMode = 1;
uint8_t _isEnablePeakHold = 1;

// {^
uint8_t _isButtonModeDown = 0;
uint16_t _buttonModeDownTime = 0;
uint8_t _isButtonModeLongPress = 0;
uint8_t _isButtonPeakHoldDown = 0;
uint16_t _buttonPeakHoldDownTime = 0;
uint8_t _isButtonPeakHoldLongPress = 0;

// \TCN
uint16_t _displayLevelCycle = 0;
uint16_t _displayAutoRangeCycle = 0;
uint16_t _displayPeakHoldCycle = 0;

// \l
int8_t _displayLevel = 0;
int8_t _displayLevelFullRangeValue = 0;
int8_t _displayPeakHold = 0;
int8_t _displayPeakHoldFullRangeValue = 0;

// 邳
uint8_t _isBrightnessAdjustment = 0;
uint8_t __brightnessValue = BRIGHTNESS_DEFAULT;

// F̏z
uint8_t _colorCirculationCycle = 0;
int8_t _colorCirculationIndex = NUMBER_OF_PIXELS - 1;

// ̌v
uint32_t _sumSoundPressureLevelInputLogarithm = 0;
uint16_t _levelSoundPressure = 0;
uint8_t _soundPressureCycle = 0;

// ΐ\(1 - 512)
const uint16_t logarithmicTable[] = {
       0,  301,  477,  602,  699,  778,  845,  903,  954, 1000, 1041, 1079, 1114, 1146, 1176, 1204,
    1230, 1255, 1279, 1301, 1322, 1342, 1362, 1380, 1398, 1415, 1431, 1447, 1462, 1477, 1491, 1505,
    1519, 1531, 1544, 1556, 1568, 1580, 1591, 1602, 1613, 1623, 1633, 1643, 1653, 1663, 1672, 1681,
    1690, 1699, 1708, 1716, 1724, 1732, 1740, 1748, 1756, 1763, 1771, 1778, 1785, 1792, 1799, 1806,
    1813, 1820, 1826, 1833, 1839, 1845, 1851, 1857, 1863, 1869, 1875, 1881, 1886, 1892, 1898, 1903,
    1908, 1914, 1919, 1924, 1929, 1934, 1940, 1944, 1949, 1954, 1959, 1964, 1968, 1973, 1978, 1982,
    1987, 1991, 1996, 2000, 2004, 2009, 2013, 2017, 2021, 2025, 2029, 2033, 2037, 2041, 2045, 2049,
    2053, 2057, 2061, 2064, 2068, 2072, 2076, 2079, 2083, 2086, 2090, 2093, 2097, 2100, 2104, 2107,
    2111, 2114, 2117, 2121, 2124, 2127, 2130, 2134, 2137, 2140, 2143, 2146, 2149, 2152, 2155, 2158,
    2161, 2164, 2167, 2170, 2173, 2176, 2179, 2182, 2185, 2188, 2190, 2193, 2196, 2199, 2201, 2204,
    2207, 2210, 2212, 2215, 2217, 2220, 2223, 2225, 2228, 2230, 2233, 2236, 2238, 2241, 2243, 2246,
    2248, 2250, 2253, 2255, 2258, 2260, 2262, 2265, 2267, 2270, 2272, 2274, 2276, 2279, 2281, 2283,
    2286, 2288, 2290, 2292, 2294, 2297, 2299, 2301, 2303, 2305, 2307, 2310, 2312, 2314, 2316, 2318,
    2320, 2322, 2324, 2326, 2328, 2330, 2332, 2334, 2336, 2338, 2340, 2342, 2344, 2346, 2348, 2350,
    2352, 2354, 2356, 2358, 2360, 2362, 2364, 2365, 2367, 2369, 2371, 2373, 2375, 2377, 2378, 2380,
    2382, 2384, 2386, 2387, 2389, 2391, 2393, 2394, 2396, 2398, 2400, 2401, 2403, 2405, 2407, 2408,
    2410, 2412, 2413, 2415, 2417, 2418, 2420, 2422, 2423, 2425, 2427, 2428, 2430, 2431, 2433, 2435,
    2436, 2438, 2439, 2441, 2442, 2444, 2446, 2447, 2449, 2450, 2452, 2453, 2455, 2456, 2458, 2459,
    2461, 2462, 2464, 2465, 2467, 2468, 2470, 2471, 2473, 2474, 2476, 2477, 2479, 2480, 2481, 2483,
    2484, 2486, 2487, 2489, 2490, 2491, 2493, 2494, 2496, 2497, 2498, 2500, 2501, 2502, 2504, 2505,
    2507, 2508, 2509, 2511, 2512, 2513, 2515, 2516, 2517, 2519, 2520, 2521, 2522, 2524, 2525, 2526,
    2528, 2529, 2530, 2531, 2533, 2534, 2535, 2537, 2538, 2539, 2540, 2542, 2543, 2544, 2545, 2547,
    2548, 2549, 2550, 2551, 2553, 2554, 2555, 2556, 2558, 2559, 2560, 2561, 2562, 2563, 2565, 2566,
    2567, 2568, 2569, 2571, 2572, 2573, 2574, 2575, 2576, 2577, 2579, 2580, 2581, 2582, 2583, 2584,
    2585, 2587, 2588, 2589, 2590, 2591, 2592, 2593, 2594, 2595, 2597, 2598, 2599, 2600, 2601, 2602,
    2603, 2604, 2605, 2606, 2607, 2609, 2610, 2611, 2612, 2613, 2614, 2615, 2616, 2617, 2618, 2619,
    2620, 2621, 2622, 2623, 2624, 2625, 2626, 2627, 2628, 2629, 2630, 2631, 2632, 2633, 2634, 2635,
    2636, 2637, 2638, 2639, 2640, 2641, 2642, 2643, 2644, 2645, 2646, 2647, 2648, 2649, 2650, 2651,
    2652, 2653, 2654, 2655, 2656, 2657, 2658, 2659, 2660, 2661, 2662, 2663, 2664, 2665, 2666, 2667,
    2667, 2668, 2669, 2670, 2671, 2672, 2673, 2674, 2675, 2676, 2677, 2678, 2679, 2679, 2680, 2681,
    2682, 2683, 2684, 2685, 2686, 2687, 2688, 2688, 2689, 2690, 2691, 2692, 2693, 2694, 2695, 2695,
    2696, 2697, 2698, 2699, 2700, 2701, 2702, 2702, 2703, 2704, 2705, 2706, 2707, 2708, 2708, 2709
};
// J[pbgiFj
const uint8_t rgbNiji[] = {
    255,   0,   0, 255,  24,   0, 255,  48,   0, 255,  72,   0,
    255,  96,   0, 255, 120,   0, 255, 144,   0, 255, 168,   0,
    255, 192,   0, 255, 216,   0, 255, 240,   0, 235, 255,   0,
    187, 255,   0, 138, 255,   0,  90, 255,   0,  42, 255,   0,
      0, 252,   6,   0, 228,  55,   0, 204, 103,   0, 180, 151,
      0, 156, 199,   0, 132, 248,   0, 107, 255,   0,  83, 255,
      0,  59, 255,   0,  35, 255,   0,  11, 255,  13,   0, 255,
     37,   0, 255,  61,   0, 255,  85,   0, 255, 109,   0, 255
};
// J[pbgizj
const uint8_t rgbRotate[] = {
    255,  27,   0, 255,  54,   0, 255,  82,   0, 255, 109,   0,
    255, 137,   0, 255, 164,   0, 255, 192,   0, 255, 219,   0,
    255, 247,   0, 214, 255,   0, 159, 255,   0, 104, 255,   0,
     49, 255,   0,   0, 252,   6,   0, 225,  62,   0, 197, 117,
      0, 170, 172,   0, 142, 227,   0, 114, 255,   0,  86, 255,
      0,  59, 255,   0,  31, 255,   0,   4, 255,  24,   0, 255,
     51,   0, 255,  78,   0, 255, 106,   0, 255, 134,   0, 240,
    164,   0, 180, 194,   0, 120, 224,   0,  60, 255,   0,   0
};


/**
 * LogvZ
 * 1000log(n)Ԃ
 * param n 1512w肷
 */
uint16_t calculateLogarithmInt16(int16_t n){
    uint16_t result = 0;
    if (n > 0 && n <= 512) {
        result = logarithmicTable[n - 1];
    }
    return result;
}

/**
 * \ASY̐ݒ
 * 
 * 0:ΐ\@ő僌W
 * 1:ΐ\@I[gW
 * 2:jA\@ő僌W
 * 3:jA\@I[gW
 */
void setAlgorithmMode() {
    if (__modeAlgorithm == 0) {
        _isLogarithmicMode = 1;
        _isAutoRangeMode = 0;
    }
    else if (__modeAlgorithm == 1) {
        _isLogarithmicMode = 1;
        _isAutoRangeMode = 1;
    }
    else if (__modeAlgorithm == 2) {
         _isLogarithmicMode = 0;
        _isAutoRangeMode = 0;
    }
    else if (__modeAlgorithm == 3) {
        _isLogarithmicMode = 0;
        _isAutoRangeMode = 1;
    }
}

/**
 * s[Nz[̕\̐ݒ
 * 
 * 0:s[Nz[hiʏ : 320msj
 * 1:s[Nz[hi : 640msj
 * 2:s[Nz[hȂ
 */
void setPeakHoldMode() {
    if (__modePeakHold == 0) {
        _isEnablePeakHold = 1;
        _peakHoldTime = TIMER_PEAK_HOLD;
    }
    else if (__modePeakHold == 1) {
        _isEnablePeakHold = 1;
        _peakHoldTime = TIMER_PEAK_HOLD * 2;
    }
    else if (__modePeakHold == 2) {
        _isEnablePeakHold = 0;
    }
}

// -------------------------------------------------------------------------------------------------
// n[hEFA@ubW@RGBLEDȊO

// EEPROM
void eepromWrite(uint16_t address, uint8_t value) {
    DATAEE_WriteByte(address, value);
}

uint8_t eepromRead(uint16_t address) {
    return DATAEE_ReadByte(address);
}

// Serial
void serialPrintInt8(uint8_t n) {
    uint8_t one = n % 10;
    uint8_t ten = (n % 100) / 10;
    uint8_t hundred = n / 100;
    EUSART_Write('0' + hundred);
    EUSART_Write('0' + ten);
    EUSART_Write('0' + one);
}

void serialPrintInt16(int16_t n) {
    int16_t one = n % 10;
    int16_t ten = (n % 100) / 10;
    int16_t hundred = (n % 1000) / 100;
    EUSART_Write('0' + hundred);
    EUSART_Write('0' + ten);
    EUSART_Write('0' + one);
}

void serialPrintString(char* str) {
    uint8_t c = 0;
    while ((c = *str++) != 0) {
        EUSART_Write(c);
    }
}

// IO
uint16_t adc() {
    ADC_StartConversion();
    while(!ADC_IsConversionDone());
    return ADC_GetConversionResult();
}

uint8_t input(uint8_t pin) {
    if (pin == PIN_BUTTON_MODE) {
        return BTN_MODE_GetValue();
    } else if (pin == PIN_BUTTON_PEAK_HOLD) {
        return BTN_PEAK_GetValue();
    }
}

void output(uint8_t pin, uint8_t value) {
    if (pin == PIN_LED_LOGARITHMIC) {
        if (value == 0) {
            LED_LOG_SetLow();
        } else {
            LED_LOG_SetHigh();
        }
    } else if (pin == PIN_LED_AUTO_RANGE) {
        if (value == 0) {
            LED_AUTO_SetLow();
        } else {
            LED_AUTO_SetHigh();
        }
    }    
}


// -------------------------------------------------------------------------------------------------
// n[hEFA@ubW@RGBLED

void showPixcel() {
    WS2812_Display();
}

void setPixcelRGB(uint8_t pixcel, uint8_t r, uint8_t g, uint8_t b) {
    if (pixcel == 0) {
        WS2812_SetColor0(r, g, b);
    } else if (pixcel == 1) {
        WS2812_SetColor1(r, g, b);
    } else if (pixcel == 2) {
        WS2812_SetColor2(r, g, b);
    } else if (pixcel == 3) {
        WS2812_SetColor3(r, g, b);
    } else if (pixcel == 4) {
        WS2812_SetColor4(r, g, b);
    } else if (pixcel == 5) {
        WS2812_SetColor5(r, g, b);
    } else if (pixcel == 6) {
        WS2812_SetColor6(r, g, b);
    } else if (pixcel == 7) {
        WS2812_SetColor7(r, g, b);
    } else if (pixcel == 8) {
        WS2812_SetColor8(r, g, b);
    } else if (pixcel == 9) {
        WS2812_SetColor9(r, g, b);
    } else if (pixcel == 10) {
        WS2812_SetColor10(r, g, b);
    } else if (pixcel == 11) {
        WS2812_SetColor11(r, g, b);
    } else if (pixcel == 12) {
        WS2812_SetColor12(r, g, b);
    } else if (pixcel == 13) {
        WS2812_SetColor13(r, g, b);
    } else if (pixcel == 14) {
        WS2812_SetColor14(r, g, b);
    } else if (pixcel == 15) {
        WS2812_SetColor15(r, g, b);
    } else if (pixcel == 16) {
        WS2812_SetColor16(r, g, b);
    } else if (pixcel == 17) {
        WS2812_SetColor17(r, g, b);
    } else if (pixcel == 18) {
        WS2812_SetColor18(r, g, b);
    } else if (pixcel == 19) {
        WS2812_SetColor19(r, g, b);
    } else if (pixcel == 20) {
        WS2812_SetColor20(r, g, b);
    } else if (pixcel == 21) {
        WS2812_SetColor21(r, g, b);
    } else if (pixcel == 22) {
        WS2812_SetColor22(r, g, b);
    } else if (pixcel == 23) {
        WS2812_SetColor23(r, g, b);
    } else if (pixcel == 24) {
        WS2812_SetColor24(r, g, b);
    } else if (pixcel == 25) {
        WS2812_SetColor25(r, g, b);
    } else if (pixcel == 26) {
        WS2812_SetColor26(r, g, b);
    } else if (pixcel == 27) {
        WS2812_SetColor27(r, g, b);
    } else if (pixcel == 28) {
        WS2812_SetColor28(r, g, b);
    } else if (pixcel == 29) {
        WS2812_SetColor29(r, g, b);
    } else if (pixcel == 30) {
        WS2812_SetColor30(r, g, b);
    } else if (pixcel == 31) {
        WS2812_SetColor31(r, g, b);
    }    
}

void setPixcelBlack(uint8_t pixcel) {
    setPixcelRGB(pixcel, 0, 0, 0);
}

void setPixcel(uint8_t pixcel, uint8_t levelColorNumber) {

    int8_t colorIndex = levelColorNumber - 1;
    uint8_t address = 0;
    uint8_t r = 0;
    uint8_t g = 0;
    uint8_t b = 0;

    if (__modeDisplay == 0) {
        // ̐F̕сiF̏j
        address = (31 - colorIndex) * 3;
        r = rgbNiji[address++];
        g = rgbNiji[address++];
        b = rgbNiji[address];
    } else if (__modeDisplay == 1) {
        // ~̐F̕сiF̋tj
        address = colorIndex * 3;
        r = rgbNiji[address++];
        g = rgbNiji[address++];
        b = rgbNiji[address];
    } else if (__modeDisplay == 2) {
        // F̏z
        colorIndex = _colorCirculationIndex + colorIndex;
        if (colorIndex > 31) {
            colorIndex = colorIndex - 31;
        }
        address = (31 - colorIndex) * 3;
        r = rgbRotate[address++];
        g = rgbRotate[address++];
        b = rgbRotate[address];
    }
    
    // 邳
    r = r >> __brightnessValue;
    g = g >> __brightnessValue;
    b = b >> __brightnessValue;

    setPixcelRGB(pixcel, r, g, b);
}

// -------------------------------------------------------------------------------------------------
void soundPressureView(uint16_t level);
void logarithmView(uint16_t level);
void linearView(uint16_t level);
void displayGraph();
void computeDisplayLevel(int8_t level, int8_t levelFullRangeValue);
void brightnessAdjustment();
void measure();

/**
 * C^[o^C}10ms
 */
void intervalTimer10ms() {

    measure();
   
     // F̏z
    _colorCirculationCycle++;
    if (_colorCirculationCycle > TIMER_COLOR_CIRCULATION_INDEX) {
        _colorCirculationCycle = 0;
        _colorCirculationIndex--;
        if (_colorCirculationIndex < 0) {
            _colorCirculationIndex = NUMBER_OF_PIXELS - 1;
        }
    }

    // 邳̒
    if (_isBrightnessAdjustment == 1) {
        brightnessAdjustment();
        return;
    }

    // LED
    if (__modeAlgorithm < 4) {
        output(PIN_LED_LOGARITHMIC, _isLogarithmicMode); 
        output(PIN_LED_AUTO_RANGE, _isAutoRangeMode); 
    } else {
        output(PIN_LED_LOGARITHMIC, 0); 
        output(PIN_LED_AUTO_RANGE, 0); 
    }

    // [h{^
    if (input(PIN_BUTTON_MODE) == 0) {
        if (_isButtonModeDown == 0) {
            _isButtonModeDown = 1;
            _buttonModeDownTime = 0;
            // Button down
        }
        else {
            if (_isButtonModeLongPress == 0) {
                _buttonModeDownTime++;
                // Button down keep
                if (_buttonModeDownTime == TIMER_LONG_PRESS) {
                    _isButtonModeLongPress = 1;
                    // Long press

                    if (__isRevers == 0 && _isBrightnessAdjustment == 0) {
                        _isBrightnessAdjustment = 1;
                    } else {
                        __isRevers++;
                        if (__isRevers > 1) {
                            __isRevers = 0; 
                        }
                        eepromWrite(EEPROM_MODE_REVERS, __isRevers);
                    }
                }
            } else {
                // Long press repeat
            }
        }
    }
    else {
        if (_isButtonModeDown == 1) {
            _isButtonModeDown = 0;
            // Button up
            if (_isButtonModeLongPress == 1) {
                _isButtonModeLongPress = 0;
            }
            else {
                __modeAlgorithm++;
                if (__modeAlgorithm > 4) {
                    __modeAlgorithm = 0; 
                }
                eepromWrite(EEPROM_MODE_ALGORITHM, __modeAlgorithm);
                setAlgorithmMode();
            }
        }
    }
    
    // s[Nz[h{^
    if (input(PIN_BUTTON_PEAK_HOLD) == 0) {
        if (_isButtonPeakHoldDown == 0) {
            _isButtonPeakHoldDown = 1;
            _buttonPeakHoldDownTime = 0;
            // Button down
        }
        else {
            if (_isButtonPeakHoldLongPress == 0) {
                _buttonPeakHoldDownTime++;
               // Button down keep
               if (_buttonPeakHoldDownTime == TIMER_LONG_PRESS) {
                   _isButtonPeakHoldLongPress = 1;
                   // Long press             
                   __modeDisplay++;
                   if (__modeDisplay > 2) {
                       __modeDisplay = 0; 
                   }
                   eepromWrite(EEPROM_MODE_DISPLAY, __modeDisplay);
               }
            } else {
                // Long press repeat
            }
        }
    }
    else {
        if (_isButtonPeakHoldDown == 1) {
            _isButtonPeakHoldDown = 0;
            // Button up
            if (_isButtonPeakHoldLongPress == 1) {
                _isButtonPeakHoldLongPress = 0;
            }
            else {
                __modePeakHold++;
                if (__modePeakHold > 2) {
                    __modePeakHold = 0;
                }
                eepromWrite(EEPROM_MODE_PEAK_HOLD, __modePeakHold);
                setPeakHoldMode();
            }
        }
    }

    // ItZbgvZ
    if (_measuredValue > 0) {
        _adcOffsetCycle++;
        uint16_t value = _sumMeasuredValue;
        _sumMeasuredValue = value + _measuredValue;
        _measuredValue = 0;
        if (_adcOffsetCycle > TIMER_ADC_OFFSET_CALCULATION) {
            // vԓ̍ől̕ς߂
            _adcOffset = _sumMeasuredValue / _adcOffsetCycle;
            _adcOffsetCycle = 0;
            _sumMeasuredValue = 0;
        }
    }
    
    // mCYo
    if (_adcOffset > 0 ) {

        if (_amplitude < __noizeThreshold) {
            _noizeCycle++;
            _noizeValueTable[_amplitude]++;
            if (_noizeCycle > TIMER_NOIZE_DETECTION) {
                uint16_t point = 0;
                for (uint8_t n = 0; n < __noizeThreshold; n++) {
                    point = point + _noizeValueTable[n];
                    if (point > _noizeValueUpThreshold) {
                        if (__noize < n) {
                            __noize = n;
                            eepromWrite(EEPROM_NOIZE_DEFAULT, __noize);
                            break;
                        }
                    }
                    if (point > _noizeValueUpThreshold) {
                        if  (__noize > n) {
                            __noize = n;
                            eepromWrite(EEPROM_NOIZE_DEFAULT, __noize);
                            break;
                        }
                    }
                }
                // mCY̍őlo
                for (uint8_t n = __noizeThreshold - 1; n > 0; n--) {
                    if (_noizeValueTable[n] == 0) {
                        if (__noizeThreshold > n + NOIZE_THRESHOLD_PLAY) {
                            __noizeThreshold = n + NOIZE_THRESHOLD_PLAY;
                            eepromWrite(EEPROM_NOIZE_THRESHOLD, __noizeThreshold);
                        }
                    }
                    else {
                        break;  
                    }
                }

                _noizeCycle = 0;
                for (uint8_t n = 0; n < NOIZE_THRESHOLD_INITIAL_VALUE; n++) {
                    _noizeValueTable[n] = 0;
                }
            }
        }
        else {
            _noizeCycle = 0;
            for (uint8_t n = 0; n < NOIZE_THRESHOLD_INITIAL_VALUE; n++) {
                _noizeValueTable[n] = 0;
            }
        }
    }
    
    // mCY
    int16_t noize = __noize;
    noize = noize + NOIZE_PLAY;
    if (noize > NOIZE_MAX) {
        noize = NOIZE_MAX;
    }
    int16_t level = _amplitude - noize;
    if (level < 0) {
        level = 0;
    }
            
    // \ASY̌vZ
    if (__modeAlgorithm == 4) {
        soundPressureView(_amplitude);
    } else {
        if (_isLogarithmicMode == 1) {
            uint16_t amplitude = _amplitude;
            uint16_t noizeLevel = amplitude - level;
            _noizeLevelLogarithm = calculateLogarithmInt16(noizeLevel);
            logarithmView(amplitude);
        }
        else {
            linearView(level);
        }
    }

    // Ot\
    displayGraph();
 
    _detectedAmplitude = _amplitude;
    _amplitude = 0;
}
// -------------------------------------------------------------------------------------------------

/**
 * ̌v
 */
void measure() {

    uint16_t v = adc();

    // ől
    if (_measuredValue < v) {
        _measuredValue = v;
    }

    // U
    if (_adcOffset > 0) {
        
        // őU̐Βl擾
        uint16_t amplitude = 0;
        if ( v <= _adcOffset) {
            amplitude = _adcOffset - v;
        }
        else {
            amplitude = v - _adcOffset;
        }
        if (_amplitude < amplitude){
            _amplitude = amplitude;
        }

        if (_isLogarithmicMode == 1) {
            // ő僌W̑ΐlvZ
            uint16_t maxRangeLogarithm = calculateLogarithmInt16(ANALOG_3V3 - _adcOffset);
            _maxRangeLogarithm = (maxRangeLogarithm - _noizeLevelLogarithm);
            
        }

    }    
}



/**
 * \̌vZ
 */
void soundPressureView(uint16_t level) {

    uint16_t inputLevel = level;
    int8_t resultLevel = 0;
    int16_t levelFullRangeValue = 0;
    
    // xvZ
    uint16_t noizeLevelLogarithm = calculateLogarithmInt16(NOIZE_DEFAULT);
    uint16_t maxRangeLogarithm = calculateLogarithmInt16(ANALOG_3V3 - _adcOffset);
    uint16_t levelInputLogarithm = calculateLogarithmInt16(inputLevel);

    // mCYJbg
    maxRangeLogarithm = maxRangeLogarithm - noizeLevelLogarithm;
    if (levelInputLogarithm > noizeLevelLogarithm) {
        levelInputLogarithm = levelInputLogarithm - noizeLevelLogarithm;
    } else {
        levelInputLogarithm = 0;
    }

    if (_soundPressureCycle < TIMER_SOUND_PRESURE) {
        _soundPressureCycle++;
        _sumSoundPressureLevelInputLogarithm = _sumSoundPressureLevelInputLogarithm + levelInputLogarithm;
    } else {
        _soundPressureCycle = 0;
        levelInputLogarithm = _sumSoundPressureLevelInputLogarithm / TIMER_SOUND_PRESURE;
        levelFullRangeValue = (NUMBER_OF_PIXELS + 1) * levelInputLogarithm / maxRangeLogarithm;
        if (levelFullRangeValue > NUMBER_OF_PIXELS ) {
            levelFullRangeValue = NUMBER_OF_PIXELS;
        }
        
        _sumSoundPressureLevelInputLogarithm = 0;
        _levelSoundPressure = levelFullRangeValue;
        output(PIN_LED_LOGARITHMIC, 1); 
    }

    // \vZ
    levelFullRangeValue = _levelSoundPressure;
    resultLevel = levelFullRangeValue;
    computeDisplayLevel(resultLevel, levelFullRangeValue);
}


/**
 * ΐ\̌vZ
 * pram level AiOol̐U
 */
void logarithmView(uint16_t level) {

    uint16_t inputLevel = level;
    int8_t resultLevel = 0;
    int16_t levelFullRangeValue = 0;
    
    // xvZ
    uint16_t levelNoizeLogarithm = _noizeLevelLogarithm;
    uint16_t levelInputLogarithm = calculateLogarithmInt16(inputLevel);
    levelInputLogarithm = levelInputLogarithm - levelNoizeLogarithm;

    levelFullRangeValue = (NUMBER_OF_PIXELS + 1) * levelInputLogarithm / _maxRangeLogarithm;
    if (levelFullRangeValue > NUMBER_OF_PIXELS ) {
        levelFullRangeValue = NUMBER_OF_PIXELS;
    }
    if (_isAutoRangeMode == 0) {
        // ő僌W
        resultLevel = levelFullRangeValue;
    }
    else {
        // I[gW
        if (_range < inputLevel) {
            _range = inputLevel;
            _displayAutoRangeCycle = 0;
        }
        _displayAutoRangeCycle++;
        if (_displayAutoRangeCycle > TIMER_AUTO_RANGE) {
            _range = RANGE_LOWER_BOUND;
        }

        uint16_t rangeLogarithm = calculateLogarithmInt16(_range);
        rangeLogarithm = rangeLogarithm - levelNoizeLogarithm;

        resultLevel = (NUMBER_OF_PIXELS + 1) * levelInputLogarithm / rangeLogarithm;
        if (resultLevel > NUMBER_OF_PIXELS) {
            resultLevel = NUMBER_OF_PIXELS;
        }
    }

    // \vZ
    computeDisplayLevel(resultLevel, levelFullRangeValue);
}

/**
 * jA\̌vZ
 * pram level AiOol̐U
 */
void linearView(uint16_t level) {

    uint16_t inputLevel = level;
    int8_t resultLevel = 0;

    // xvZ
    int16_t levelFullRangeValue = inputLevel * (NUMBER_OF_PIXELS + 1) / (ANALOG_3V3 - _adcOffset);
    if (levelFullRangeValue > NUMBER_OF_PIXELS ) {
        levelFullRangeValue = NUMBER_OF_PIXELS;
    }
    if (_isAutoRangeMode == 0) {
        // ő僌W
        resultLevel = levelFullRangeValue;
    }
    else {
        // I[gW
        if (_range < inputLevel) {
            _range = inputLevel;
            _displayAutoRangeCycle = 0;
        }
        _displayAutoRangeCycle++;
        if (_displayAutoRangeCycle > TIMER_AUTO_RANGE) {
            _range = NUMBER_OF_PIXELS;
        }
        
        resultLevel = inputLevel * NUMBER_OF_PIXELS / _range;
        if (resultLevel > NUMBER_OF_PIXELS) {
            resultLevel = NUMBER_OF_PIXELS;
        }
    }

    // \vZ
    computeDisplayLevel(resultLevel, levelFullRangeValue);
}

/**
 * \vZ
 * param level ݂̃Wł̒l
 * param levelFullRangeValue ő僌Wł̒l
 */
void computeDisplayLevel(int8_t level, int8_t levelFullRangeValue) {
    // \x
    if (level > _displayLevel) {
        _displayLevel = level;
        _displayLevelFullRangeValue = levelFullRangeValue;
    }
    else{
        _displayLevelCycle++;
        if (_displayLevelCycle > TIMER_LEVEL) {
            _displayLevelCycle = 0;
            _displayLevel--;
        }
    }  
    // s[Nz[h
    if (_displayLevel > _displayPeakHold) {
        _displayPeakHold = _displayLevel;
        _displayPeakHoldFullRangeValue = levelFullRangeValue;
        _displayPeakHoldCycle = 0;
    }
    else {
        _displayPeakHoldCycle++;
        if (_displayPeakHoldCycle > _peakHoldTime){
            _displayPeakHoldCycle = 0;
            if (_displayPeakHold > 0) {
                _displayPeakHold--;
            }
        }
    }
}

/**
 * Ot\
 */
void displayGraph() {
    
    // ʂɓ_鐔
    int8_t level = _displayLevel;
    // ʏ̃s[Nz[ḧʒu
    int8_t peak = _displayPeakHold;
    // ő僌W̃s[Nz[h̒l
    uint8_t peakFullRange = _displayPeakHoldFullRangeValue;
    uint8_t isEnablePeakHold = _isEnablePeakHold;
    uint8_t isRevers = __isRevers;

    // Ot\
    for (uint8_t x = 1; x <= NUMBER_OF_PIXELS; x++) {
        uint8_t index = x - 1;
        if (isRevers == 1) {
            index = 31 - index;
        }
        if (level == peak) {
            if (x < peak) {
                  // x̕\
                 setPixcel(index, x);                
            } else {
                if ( x == peak && isEnablePeakHold == 1) {
                    // Peak̕\
                   setPixcel(index, peakFullRange);
                }
                else {
                    setPixcelBlack(index);
                }
            }
        }
        else {
            if (x <= level) {
                  // x̕\
                 setPixcel(index, x);                
            } else {
                if ( x == peak && isEnablePeakHold == 1) {
                    // Peak̕\
                    setPixcel(index, peakFullRange);
                }
                else {
                    setPixcelBlack(index);
                }
            }
        }
    }

    showPixcel();
}

// -------------------------------------------------------------------------------------------------

/**
 * 邳
 */
void brightnessAdjustment() {

    // [h{^
    if (input(PIN_BUTTON_MODE) == 0) {
        if (_isButtonModeDown == 0) {
            _isButtonModeDown = 1;
            _buttonModeDownTime = 0;
            // Button down
        }
        else {
            _buttonModeDownTime++;
            // Button down keep
            if (_buttonModeDownTime == TIMER_LONG_PRESS) {
                _isButtonModeLongPress = 1;
                // Long press
                
                _isBrightnessAdjustment = 0;
                __isRevers = 1;
                eepromWrite(EEPROM_MODE_REVERS, __isRevers);
                
            }
        }
    }
    else {
        if (_isButtonModeDown == 1) {
            _isButtonModeDown = 0;
            // Button up
            if (_isButtonModeLongPress == 1) {
                _isButtonModeLongPress = 0;
                // After Long press
            }
            else {
                // After click
                __brightnessValue--;
                if (__brightnessValue < BRIGHTNESS_MIN) {
                    __brightnessValue = BRIGHTNESS_MIN;
                }
                eepromWrite(EEPROM_BRIGHTNESS, __brightnessValue);                
            }
        }
    }
    // s[Nz[h{^
    if (input(PIN_BUTTON_PEAK_HOLD) == 0) {
        if (_isButtonPeakHoldDown == 0) {
            _isButtonPeakHoldDown = 1;
            _buttonPeakHoldDownTime = 0;
            // Button down
        }
        else {
            _buttonPeakHoldDownTime++;
            // Button down keep
            if (_buttonPeakHoldDownTime == TIMER_LONG_PRESS) {
                _isButtonPeakHoldLongPress = 1;
                // Long press             

            }
        }
    }
    else {
        if (_isButtonPeakHoldDown == 1) {
            _isButtonPeakHoldDown = 0;
            // Button up
            if (_isButtonPeakHoldLongPress == 1) {
                _isButtonPeakHoldLongPress = 0;
                // After Long press
            }
            else {
                // After click
                __brightnessValue++;
                if (__brightnessValue > BRIGHTNESS_MAX) {
                    __brightnessValue = BRIGHTNESS_MAX;
                }
                eepromWrite(EEPROM_BRIGHTNESS, __brightnessValue);
            }
        }
    }
    
    // ׂẴhbg_
    for (int8_t i = 0; i < 32; i++) {
        setPixcel(i, 32 - i);
    }

    showPixcel();
}

// -------------------------------------------------------------------------------------------------

/**
 * EEPROM̕ۑ
 */
void loadData() {
    uint8_t id  = eepromRead(EEPROM_INITIALIZE);
    if (id != INITIALIZE_ID) {
        eepromWrite(EEPROM_NOIZE_DEFAULT, NOIZE_DEFAULT);
        eepromWrite(EEPROM_NOIZE_THRESHOLD, NOIZE_THRESHOLD_INITIAL_VALUE);
        eepromWrite(EEPROM_MODE_ALGORITHM, 0);
        eepromWrite(EEPROM_MODE_PEAK_HOLD, 0);
        eepromWrite(EEPROM_MODE_DISPLAY, 0);
        eepromWrite(EEPROM_MODE_REVERS, DEFAULT_REVERS);      
        eepromWrite(EEPROM_BRIGHTNESS, BRIGHTNESS_DEFAULT);
        // l݂̏IID
        eepromWrite(EEPROM_INITIALIZE, INITIALIZE_ID);
    } else {
        __noize = eepromRead(EEPROM_NOIZE_DEFAULT);
        __noizeThreshold = eepromRead(EEPROM_NOIZE_THRESHOLD);
        __modeAlgorithm = eepromRead(EEPROM_MODE_ALGORITHM);
        __modePeakHold = eepromRead(EEPROM_MODE_PEAK_HOLD);
        __modeDisplay = eepromRead(EEPROM_MODE_DISPLAY);
        __isRevers = eepromRead(EEPROM_MODE_REVERS);
        __brightnessValue = eepromRead(EEPROM_BRIGHTNESS);
    }
}

/**
 * \tgEFAZbg̃{^͂`FbN
 * Zbgs̏ꍇ͖邳ȊO̕ۑB
 * (1)mCY̊wKf[^
 *   mCYƂăJbgM̋
 * @mCY͂臒l
 * (2)ݒ
 * @\ASY
 * @s[Nz[h̃[h
 * @]\
 * @\F̏
 * @Ot\̖邳
 */
void checkSoftwareReset() {
    uint8_t isInitialize = 0;
    while (input(PIN_BUTTON_PEAK_HOLD) == 0 || input(PIN_BUTTON_MODE) == 0) {
        isInitialize = 1;
    }
    if (isInitialize == 1) {
        eepromWrite(EEPROM_NOIZE_DEFAULT, NOIZE_DEFAULT);
        eepromWrite(EEPROM_NOIZE_THRESHOLD, NOIZE_THRESHOLD_INITIAL_VALUE);
        eepromWrite(EEPROM_MODE_ALGORITHM, 0);
        eepromWrite(EEPROM_MODE_PEAK_HOLD, 0);
        eepromWrite(EEPROM_MODE_DISPLAY, 0);
        eepromWrite(EEPROM_MODE_REVERS, DEFAULT_REVERS);      
        eepromWrite(EEPROM_BRIGHTNESS, BRIGHTNESS_DEFAULT);
    }
}

// -------------------------------------------------------------------------------------------------


/**
 * fobO\
 */
void debug() {

    serialPrintString("mode:");
    serialPrintInt16(__modeAlgorithm);
    serialPrintString(" display:");
    serialPrintInt16(__modeDisplay);
    serialPrintString(" range:");
    serialPrintInt16(_range);
    serialPrintString(" offset:");
    serialPrintInt16(_adcOffset);
    serialPrintString(" noize:");
    serialPrintInt16(__noize);
    serialPrintString(" threshold:");
    serialPrintInt16(__noizeThreshold);
    serialPrintString(" amplitude:");
    serialPrintInt16(_detectedAmplitude);
            
    serialPrintString("\r\n");
}

// -------------------------------------------------------------------------------------------------

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // ^C}Cxgnh̐ݒ
    TMR2_SetInterruptHandler(intervalTimer10ms);
    // ADC`l̐ݒ
    ADC_SelectChannel(SOUND);

    // RGBLED̏
    WS2812_Initialize();

    // Ñ{^͂`FbN
    checkSoftwareReset();

    // EEPROM̕ۑ
    loadData();

    // ݒ
    setAlgorithmMode();
    setPeakHoldMode();
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        if (SW_DEBUG_GetValue() == 0) {
            debug();
        }
    }
}
/**
 End of File
*/