/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18325
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.36 and above
        MPLAB 	          :  MPLAB X 6.00	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set DO aliases
#define DO_TRIS                 TRISAbits.TRISA4
#define DO_LAT                  LATAbits.LATA4
#define DO_PORT                 PORTAbits.RA4
#define DO_WPU                  WPUAbits.WPUA4
#define DO_OD                   ODCONAbits.ODCA4
#define DO_ANS                  ANSELAbits.ANSA4
#define DO_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define DO_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define DO_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define DO_GetValue()           PORTAbits.RA4
#define DO_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define DO_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define DO_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define DO_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define DO_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define DO_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define DO_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define DO_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set SOUND aliases
#define SOUND_TRIS                 TRISAbits.TRISA5
#define SOUND_LAT                  LATAbits.LATA5
#define SOUND_PORT                 PORTAbits.RA5
#define SOUND_WPU                  WPUAbits.WPUA5
#define SOUND_OD                   ODCONAbits.ODCA5
#define SOUND_ANS                  ANSELAbits.ANSA5
#define SOUND_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define SOUND_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define SOUND_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define SOUND_GetValue()           PORTAbits.RA5
#define SOUND_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define SOUND_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define SOUND_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define SOUND_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define SOUND_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define SOUND_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define SOUND_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define SOUND_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set BTN_PEAK aliases
#define BTN_PEAK_TRIS                 TRISCbits.TRISC0
#define BTN_PEAK_LAT                  LATCbits.LATC0
#define BTN_PEAK_PORT                 PORTCbits.RC0
#define BTN_PEAK_WPU                  WPUCbits.WPUC0
#define BTN_PEAK_OD                   ODCONCbits.ODCC0
#define BTN_PEAK_ANS                  ANSELCbits.ANSC0
#define BTN_PEAK_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define BTN_PEAK_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define BTN_PEAK_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define BTN_PEAK_GetValue()           PORTCbits.RC0
#define BTN_PEAK_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define BTN_PEAK_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define BTN_PEAK_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define BTN_PEAK_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define BTN_PEAK_SetPushPull()        do { ODCONCbits.ODCC0 = 0; } while(0)
#define BTN_PEAK_SetOpenDrain()       do { ODCONCbits.ODCC0 = 1; } while(0)
#define BTN_PEAK_SetAnalogMode()      do { ANSELCbits.ANSC0 = 1; } while(0)
#define BTN_PEAK_SetDigitalMode()     do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set BTN_MODE aliases
#define BTN_MODE_TRIS                 TRISCbits.TRISC1
#define BTN_MODE_LAT                  LATCbits.LATC1
#define BTN_MODE_PORT                 PORTCbits.RC1
#define BTN_MODE_WPU                  WPUCbits.WPUC1
#define BTN_MODE_OD                   ODCONCbits.ODCC1
#define BTN_MODE_ANS                  ANSELCbits.ANSC1
#define BTN_MODE_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define BTN_MODE_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define BTN_MODE_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define BTN_MODE_GetValue()           PORTCbits.RC1
#define BTN_MODE_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define BTN_MODE_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define BTN_MODE_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define BTN_MODE_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define BTN_MODE_SetPushPull()        do { ODCONCbits.ODCC1 = 0; } while(0)
#define BTN_MODE_SetOpenDrain()       do { ODCONCbits.ODCC1 = 1; } while(0)
#define BTN_MODE_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define BTN_MODE_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set SW_DEBUG aliases
#define SW_DEBUG_TRIS                 TRISCbits.TRISC2
#define SW_DEBUG_LAT                  LATCbits.LATC2
#define SW_DEBUG_PORT                 PORTCbits.RC2
#define SW_DEBUG_WPU                  WPUCbits.WPUC2
#define SW_DEBUG_OD                   ODCONCbits.ODCC2
#define SW_DEBUG_ANS                  ANSELCbits.ANSC2
#define SW_DEBUG_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define SW_DEBUG_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define SW_DEBUG_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define SW_DEBUG_GetValue()           PORTCbits.RC2
#define SW_DEBUG_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define SW_DEBUG_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define SW_DEBUG_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define SW_DEBUG_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define SW_DEBUG_SetPushPull()        do { ODCONCbits.ODCC2 = 0; } while(0)
#define SW_DEBUG_SetOpenDrain()       do { ODCONCbits.ODCC2 = 1; } while(0)
#define SW_DEBUG_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define SW_DEBUG_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetPullup()             do { WPUCbits.WPUC3 = 1; } while(0)
#define RC3_ResetPullup()           do { WPUCbits.WPUC3 = 0; } while(0)
#define RC3_SetAnalogMode()         do { ANSELCbits.ANSC3 = 1; } while(0)
#define RC3_SetDigitalMode()        do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set LED_LOG aliases
#define LED_LOG_TRIS                 TRISCbits.TRISC4
#define LED_LOG_LAT                  LATCbits.LATC4
#define LED_LOG_PORT                 PORTCbits.RC4
#define LED_LOG_WPU                  WPUCbits.WPUC4
#define LED_LOG_OD                   ODCONCbits.ODCC4
#define LED_LOG_ANS                  ANSELCbits.ANSC4
#define LED_LOG_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define LED_LOG_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define LED_LOG_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define LED_LOG_GetValue()           PORTCbits.RC4
#define LED_LOG_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define LED_LOG_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define LED_LOG_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define LED_LOG_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define LED_LOG_SetPushPull()        do { ODCONCbits.ODCC4 = 0; } while(0)
#define LED_LOG_SetOpenDrain()       do { ODCONCbits.ODCC4 = 1; } while(0)
#define LED_LOG_SetAnalogMode()      do { ANSELCbits.ANSC4 = 1; } while(0)
#define LED_LOG_SetDigitalMode()     do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set LED_AUTO aliases
#define LED_AUTO_TRIS                 TRISCbits.TRISC5
#define LED_AUTO_LAT                  LATCbits.LATC5
#define LED_AUTO_PORT                 PORTCbits.RC5
#define LED_AUTO_WPU                  WPUCbits.WPUC5
#define LED_AUTO_OD                   ODCONCbits.ODCC5
#define LED_AUTO_ANS                  ANSELCbits.ANSC5
#define LED_AUTO_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define LED_AUTO_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define LED_AUTO_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define LED_AUTO_GetValue()           PORTCbits.RC5
#define LED_AUTO_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define LED_AUTO_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define LED_AUTO_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define LED_AUTO_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define LED_AUTO_SetPushPull()        do { ODCONCbits.ODCC5 = 0; } while(0)
#define LED_AUTO_SetOpenDrain()       do { ODCONCbits.ODCC5 = 1; } while(0)
#define LED_AUTO_SetAnalogMode()      do { ANSELCbits.ANSC5 = 1; } while(0)
#define LED_AUTO_SetDigitalMode()     do { ANSELCbits.ANSC5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/