/**
 * WS2812
 * 
 * Required system clock is 32MHz.
 * 
 * [Configuration required for #asm]
 * XC8 Global Options: C cstandard [C90]
 * 
 * MPLAB X IDE v5.30 with XC8 Ver2.05
 * (c)2020 Futoshi Sumikawa. 2020/03/25
 * (c)2022 Futoshi Sumikawa. 2022/08/01
 */

/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#include <xc.h>         /* XC8 General Include File */
#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#include "ws2812.h"

// Used for 1 byte transmission.
uint8_t neoPixelRGB = 0;

// Pixel color.
uint8_t neoPixelG0 = 0;
uint8_t neoPixelR0 = 0;
uint8_t neoPixelB0 = 0;

uint8_t neoPixelG1 = 0;
uint8_t neoPixelR1 = 0;
uint8_t neoPixelB1 = 0;

uint8_t neoPixelG2 = 0;
uint8_t neoPixelR2 = 0;
uint8_t neoPixelB2 = 0;

uint8_t neoPixelG3 = 0;
uint8_t neoPixelR3 = 0;
uint8_t neoPixelB3 = 0;

uint8_t neoPixelG4 = 0;
uint8_t neoPixelR4 = 0;
uint8_t neoPixelB4 = 0;

uint8_t neoPixelG5 = 0;
uint8_t neoPixelR5 = 0;
uint8_t neoPixelB5 = 0;

uint8_t neoPixelG6 = 0;
uint8_t neoPixelR6 = 0;
uint8_t neoPixelB6 = 0;

uint8_t neoPixelG7 = 0;
uint8_t neoPixelR7 = 0;
uint8_t neoPixelB7 = 0;

uint8_t neoPixelG8 = 0;
uint8_t neoPixelR8 = 0;
uint8_t neoPixelB8 = 0;

uint8_t neoPixelG9 = 0;
uint8_t neoPixelR9 = 0;
uint8_t neoPixelB9 = 0;

uint8_t neoPixelG10 = 0;
uint8_t neoPixelR10 = 0;
uint8_t neoPixelB10 = 0;

uint8_t neoPixelG11 = 0;
uint8_t neoPixelR11 = 0;
uint8_t neoPixelB11 = 0;

uint8_t neoPixelG12 = 0;
uint8_t neoPixelR12 = 0;
uint8_t neoPixelB12 = 0;

uint8_t neoPixelG13 = 0;
uint8_t neoPixelR13 = 0;
uint8_t neoPixelB13 = 0;

uint8_t neoPixelG14 = 0;
uint8_t neoPixelR14 = 0;
uint8_t neoPixelB14 = 0;

uint8_t neoPixelG15 = 0;
uint8_t neoPixelR15 = 0;
uint8_t neoPixelB15 = 0;

uint8_t neoPixelG16 = 0;
uint8_t neoPixelR16 = 0;
uint8_t neoPixelB16 = 0;

uint8_t neoPixelG17 = 0;
uint8_t neoPixelR17 = 0;
uint8_t neoPixelB17 = 0;

uint8_t neoPixelG18 = 0;
uint8_t neoPixelR18 = 0;
uint8_t neoPixelB18 = 0;

uint8_t neoPixelG19 = 0;
uint8_t neoPixelR19 = 0;
uint8_t neoPixelB19 = 0;

uint8_t neoPixelG20 = 0;
uint8_t neoPixelR20 = 0;
uint8_t neoPixelB20 = 0;

uint8_t neoPixelG21 = 0;
uint8_t neoPixelR21 = 0;
uint8_t neoPixelB21 = 0;

uint8_t neoPixelG22 = 0;
uint8_t neoPixelR22 = 0;
uint8_t neoPixelB22 = 0;

uint8_t neoPixelG23 = 0;
uint8_t neoPixelR23 = 0;
uint8_t neoPixelB23 = 0;

uint8_t neoPixelG24 = 0;
uint8_t neoPixelR24 = 0;
uint8_t neoPixelB24 = 0;

uint8_t neoPixelG25 = 0;
uint8_t neoPixelR25 = 0;
uint8_t neoPixelB25 = 0;

uint8_t neoPixelG26 = 0;
uint8_t neoPixelR26 = 0;
uint8_t neoPixelB26 = 0;

uint8_t neoPixelG27 = 0;
uint8_t neoPixelR27 = 0;
uint8_t neoPixelB27 = 0;

uint8_t neoPixelG28 = 0;
uint8_t neoPixelR28 = 0;
uint8_t neoPixelB28 = 0;

uint8_t neoPixelG29 = 0;
uint8_t neoPixelR29 = 0;
uint8_t neoPixelB29 = 0;

uint8_t neoPixelG30 = 0;
uint8_t neoPixelR30 = 0;
uint8_t neoPixelB30 = 0;

uint8_t neoPixelG31 = 0;
uint8_t neoPixelR31 = 0;
uint8_t neoPixelB31 = 0;

/**
 * Initialize all pixels to 'off'
 */
void WS2812_Initialize(void) {

    neoPixelG0 = 0;
    neoPixelR0 = 0;
    neoPixelB0 = 0;

    neoPixelG1 = 0;
    neoPixelR1 = 0;
    neoPixelB1 = 0;

    neoPixelG2 = 0;
    neoPixelR2 = 0;
    neoPixelB2 = 0;

    neoPixelG3 = 0;
    neoPixelR3 = 0;
    neoPixelB3 = 0;

    neoPixelG4 = 0;
    neoPixelR4 = 0;
    neoPixelB4 = 0;

    neoPixelG5 = 0;
    neoPixelR5 = 0;
    neoPixelB5 = 0;

    neoPixelG6 = 0;
    neoPixelR6 = 0;
    neoPixelB6 = 0;

    neoPixelG7 = 0;
    neoPixelR7 = 0;
    neoPixelB7 = 0;

    neoPixelG8 = 0;
    neoPixelR8 = 0;
    neoPixelB8 = 0;

    neoPixelG9 = 0;
    neoPixelR9 = 0;
    neoPixelB9 = 0;

    neoPixelG10 = 0;
    neoPixelR10 = 0;
    neoPixelB10 = 0;

    neoPixelG11 = 0;
    neoPixelR11 = 0;
    neoPixelB11 = 0;

    neoPixelG12 = 0;
    neoPixelR12 = 0;
    neoPixelB12 = 0;

    neoPixelG13 = 0;
    neoPixelR13 = 0;
    neoPixelB13 = 0;

    neoPixelG14 = 0;
    neoPixelR14 = 0;
    neoPixelB14 = 0;

    neoPixelG15 = 0;
    neoPixelR15 = 0;
    neoPixelB15 = 0;

    neoPixelG16 = 0;
    neoPixelR16 = 0;
    neoPixelB16 = 0;

    neoPixelG17 = 0;
    neoPixelR17 = 0;
    neoPixelB17 = 0;

    neoPixelG18 = 0;
    neoPixelR18 = 0;
    neoPixelB18 = 0;

    neoPixelG19 = 0;
    neoPixelR19 = 0;
    neoPixelB19 = 0;

    neoPixelG20 = 0;
    neoPixelR20 = 0;
    neoPixelB20 = 0;

    neoPixelG21 = 0;
    neoPixelR21 = 0;
    neoPixelB21 = 0;

    neoPixelG22 = 0;
    neoPixelR22 = 0;
    neoPixelB22 = 0;

    neoPixelG23 = 0;
    neoPixelR23 = 0;
    neoPixelB23 = 0;

    neoPixelG24 = 0;
    neoPixelR24 = 0;
    neoPixelB24 = 0;

    neoPixelG25 = 0;
    neoPixelR25 = 0;
    neoPixelB25 = 0;

    neoPixelG26 = 0;
    neoPixelR26 = 0;
    neoPixelB26 = 0;

    neoPixelG27 = 0;
    neoPixelR27 = 0;
    neoPixelB27 = 0;

    neoPixelG28 = 0;
    neoPixelR28 = 0;
    neoPixelB28 = 0;

    neoPixelG29 = 0;
    neoPixelR29 = 0;
    neoPixelB29 = 0;

    neoPixelG30 = 0;
    neoPixelR30 = 0;
    neoPixelB30 = 0;

    neoPixelG31 = 0;
    neoPixelR31 = 0;
    neoPixelB31 = 0;
    
}

void WS2812_VPOKE(uint8_t address, uint8_t data) {

    if (address == 0) {
    } else if (address == 1) {

        neoPixelG0 = data;
    } else if (address == 2) {
        neoPixelR0 = data;
    } else if (address == 3) {
        neoPixelB0 = data;
    } else if (address == 4) {

        neoPixelG1 = data;
    } else if (address == 5) {
        neoPixelR1 = data;
    } else if (address == 6) {
        neoPixelB1 = data;
    } else if (address == 7) {

        neoPixelG2 = data;
    } else if (address == 8) {
        neoPixelR2 = data;
    } else if (address == 9) {
        neoPixelB2 = data;
    } else if (address == 10) {

        neoPixelG3 = data;
    } else if (address == 11) {
        neoPixelR3 = data;
    } else if (address == 12) {
        neoPixelB3 = data;
    } else if (address == 13) {

        neoPixelG4 = data;
    } else if (address == 14) {
        neoPixelR4 = data;
    } else if (address == 15) {
        neoPixelB4 = data;
    } else if (address == 16) {

        neoPixelG5 = data;
    } else if (address == 17) {
        neoPixelR5 = data;
    } else if (address == 18) {
        neoPixelB5 = data;
    } else if (address == 19) {

        neoPixelG6 = data;
    } else if (address == 20) {
        neoPixelR6 = data;
    } else if (address == 21) {
        neoPixelB6 = data;
    } else if (address == 22) {

        neoPixelG7 = data;
    } else if (address == 23) {
        neoPixelR7 = data;
    } else if (address == 24) {
        neoPixelB7 = data;
    } else if (address == 25) {

        neoPixelG8 = data;
    } else if (address == 26) {
        neoPixelR8 = data;
    } else if (address == 27) {
        neoPixelB8 = data;
    } else if (address == 28) {

        neoPixelG9 = data;
    } else if (address == 29) {
        neoPixelR9 = data;
    } else if (address == 30) {
        neoPixelB9 = data;
    } else if (address == 31) {

        neoPixelG10 = data;
    } else if (address == 32) {
        neoPixelR10 = data;
    } else if (address == 33) {
        neoPixelB10 = data;
    } else if (address == 34) {

        neoPixelG11 = data;
    } else if (address == 35) {
        neoPixelR11 = data;
    } else if (address == 36) {
        neoPixelB11 = data;
    } else if (address == 37) {

        neoPixelG12 = data;
    } else if (address == 38) {
        neoPixelR12 = data;
    } else if (address == 39) {
        neoPixelB12 = data;
    } else if (address == 40) {

        neoPixelG13 = data;
    } else if (address == 41) {
        neoPixelR13 = data;
    } else if (address == 42) {
        neoPixelB13 = data;
    } else if (address == 43) {

        neoPixelG14 = data;
    } else if (address == 44) {
        neoPixelR14 = data;
    } else if (address == 45) {
        neoPixelB14 = data;
    } else if (address == 46) {

        neoPixelG15 = data;
    } else if (address == 47) {
        neoPixelR15 = data;
    } else if (address == 48) {
        neoPixelB15 = data;
    } else if (address == 49) {

        neoPixelG16 = data;
    } else if (address == 50) {
        neoPixelR16 = data;
    } else if (address == 51) {
        neoPixelB16 = data;
    } else if (address == 52) {

        neoPixelG17 = data;
    } else if (address == 53) {
        neoPixelR17 = data;
    } else if (address == 54) {
        neoPixelB17 = data;
    } else if (address == 55) {

        neoPixelG18 = data;
    } else if (address == 56) {
        neoPixelR18 = data;
    } else if (address == 57) {
        neoPixelB18 = data;
    } else if (address == 58) {

        neoPixelG19 = data;
    } else if (address == 59) {
        neoPixelR19 = data;
    } else if (address == 60) {
        neoPixelB19 = data;
    } else if (address == 61) {

        neoPixelG20 = data;
    } else if (address == 62) {
        neoPixelR20 = data;
    } else if (address == 63) {
        neoPixelB20 = data;
    } else if (address == 64) {

        neoPixelG21 = data;
    } else if (address == 65) {
        neoPixelR21 = data;
    } else if (address == 66) {
        neoPixelB21 = data;
    } else if (address == 67) {

        neoPixelG22 = data;
    } else if (address == 68) {
        neoPixelR22 = data;
    } else if (address == 69) {
        neoPixelB22 = data;
    } else if (address == 70) {

        neoPixelG23 = data;
    } else if (address == 71) {
        neoPixelR23 = data;
    } else if (address == 72) {
        neoPixelB23 = data;
    } else if (address == 73) {

        neoPixelG24 = data;
    } else if (address == 74) {
        neoPixelR24 = data;
    } else if (address == 75) {
        neoPixelB24 = data;
    } else if (address == 76) {

        neoPixelG25 = data;
    } else if (address == 77) {
        neoPixelR25 = data;
    } else if (address == 78) {
        neoPixelB25 = data;
    } else if (address == 79) {

        neoPixelG26 = data;
    } else if (address == 80) {
        neoPixelR26 = data;
    } else if (address == 81) {
        neoPixelB26 = data;
    } else if (address == 82) {

        neoPixelG27 = data;
    } else if (address == 83) {
        neoPixelR27 = data;
    } else if (address == 84) {
        neoPixelB27 = data;
    } else if (address == 85) {

        neoPixelG28 = data;
    } else if (address == 86) {
        neoPixelR28 = data;
    } else if (address == 87) {
        neoPixelB28 = data;
    } else if (address == 88) {

        neoPixelG29 = data;
    } else if (address == 89) {
        neoPixelR29 = data;
    } else if (address == 90) {
        neoPixelB29 = data;
    } else if (address == 91) {

        neoPixelG30 = data;
    } else if (address == 92) {
        neoPixelR30 = data;
    } else if (address == 93) {
        neoPixelB30 = data;
    } else if (address == 94) {

        neoPixelG31 = data;
    } else if (address == 95) {
        neoPixelR31 = data;
    } else if (address == 96) {
        neoPixelB31 = data;
    }

}

void WS2812_SetColor0(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG0 = g;
    neoPixelR0 = r;
    neoPixelB0 = b;
}
void WS2812_SetColor1(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG1 = g;
    neoPixelR1 = r;
    neoPixelB1 = b;
}
void WS2812_SetColor2(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG2 = g;
    neoPixelR2 = r;
    neoPixelB2 = b;
}
void WS2812_SetColor3(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG3 = g;
    neoPixelR3 = r;
    neoPixelB3 = b;
}
void WS2812_SetColor4(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG4 = g;
    neoPixelR4 = r;
    neoPixelB4 = b;
}
void WS2812_SetColor5(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG5 = g;
    neoPixelR5 = r;
    neoPixelB5 = b;
}
void WS2812_SetColor6(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG6 = g;
    neoPixelR6 = r;
    neoPixelB6 = b;
}
void WS2812_SetColor7(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG7 = g;
    neoPixelR7 = r;
    neoPixelB7 = b;
}
void WS2812_SetColor8(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG8 = g;
    neoPixelR8 = r;
    neoPixelB8 = b;
}
void WS2812_SetColor9(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG9 = g;
    neoPixelR9 = r;
    neoPixelB9 = b;
}
void WS2812_SetColor10(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG10 = g;
    neoPixelR10 = r;
    neoPixelB10 = b;
}
void WS2812_SetColor11(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG11 = g;
    neoPixelR11 = r;
    neoPixelB11 = b;
}
void WS2812_SetColor12(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG12 = g;
    neoPixelR12 = r;
    neoPixelB12 = b;
}
void WS2812_SetColor13(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG13 = g;
    neoPixelR13 = r;
    neoPixelB13 = b;
}
void WS2812_SetColor14(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG14 = g;
    neoPixelR14 = r;
    neoPixelB14 = b;
}
void WS2812_SetColor15(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG15 = g;
    neoPixelR15 = r;
    neoPixelB15 = b;
}
void WS2812_SetColor16(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG16 = g;
    neoPixelR16 = r;
    neoPixelB16 = b;
}
void WS2812_SetColor17(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG17 = g;
    neoPixelR17 = r;
    neoPixelB17 = b;
}
void WS2812_SetColor18(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG18 = g;
    neoPixelR18 = r;
    neoPixelB18 = b;
}
void WS2812_SetColor19(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG19 = g;
    neoPixelR19 = r;
    neoPixelB19 = b;
}
void WS2812_SetColor20(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG20 = g;
    neoPixelR20 = r;
    neoPixelB20 = b;
}
void WS2812_SetColor21(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG21 = g;
    neoPixelR21 = r;
    neoPixelB21 = b;
}
void WS2812_SetColor22(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG22 = g;
    neoPixelR22 = r;
    neoPixelB22 = b;
}
void WS2812_SetColor23(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG23 = g;
    neoPixelR23 = r;
    neoPixelB23 = b;
}
void WS2812_SetColor24(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG24 = g;
    neoPixelR24 = r;
    neoPixelB24 = b;
}
void WS2812_SetColor25(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG25 = g;
    neoPixelR25 = r;
    neoPixelB25 = b;
}
void WS2812_SetColor26(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG26 = g;
    neoPixelR26 = r;
    neoPixelB26 = b;
}
void WS2812_SetColor27(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG27 = g;
    neoPixelR27 = r;
    neoPixelB27 = b;
}
void WS2812_SetColor28(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG28 = g;
    neoPixelR28 = r;
    neoPixelB28 = b;
}
void WS2812_SetColor29(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG29 = g;
    neoPixelR29 = r;
    neoPixelB29 = b;
}
void WS2812_SetColor30(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG30 = g;
    neoPixelR30 = r;
    neoPixelB30 = b;
}
void WS2812_SetColor31(uint8_t r, uint8_t g, uint8_t b) {
    neoPixelG31 = g;
    neoPixelR31 = r;
    neoPixelB31 = b;
}

void WS2812_SetColor(uint8_t n, uint24_t color) {
    
    uint8_t address = n * 3 + 1;
    
    uint8_t blue = (color & 0b11111111);
    color = color >> 8;
    uint8_t green = (color & 0b11111111);
    color = color >> 8;
    uint8_t red = (color & 0b11111111);
    
    WS2812_VPOKE(address, green);
    WS2812_VPOKE(address + 1, red);
    WS2812_VPOKE(address + 2, blue);
}


/**
 * 32MHz : 1setp = 125ns
 * --------------------------------
 * WS2812C-2020 800Hz
 * code0 : |~3step(375ns)~|_7step(875ns)_|
 * code1 : |~5step(625ns)~|_5step(625ns)_|
 * --------------------------------
 * WS2812B stick8 800Hz
 * code0 : |~3step(req:400ns,375ns)~|_7step(req:850ns,875ns)_|
 * code1 : |~6step(req:800ns,750ns)~|_4step(req:450ns,500ns)_|
 * --------------------------------
 */
void WS2812_Display(void) {

#asm
    
    BANKSEL _neoPixelG0
    MOVF _neoPixelG0 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR0
    MOVF _neoPixelR0 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB0
    MOVF _neoPixelB0 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE
    
            
    BANKSEL _neoPixelG1
    MOVF _neoPixelG1 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR1
    MOVF _neoPixelR1 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB1
    MOVF _neoPixelB1 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

            
    BANKSEL _neoPixelG2
    MOVF _neoPixelG2 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR2
    MOVF _neoPixelR2 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB2
    MOVF _neoPixelB2 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

            
    BANKSEL _neoPixelG3
    MOVF _neoPixelG3 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR3
    MOVF _neoPixelR3 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB3
    MOVF _neoPixelB3 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

            
    BANKSEL _neoPixelG4
    MOVF _neoPixelG4 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR4
    MOVF _neoPixelR4 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB4
    MOVF _neoPixelB4 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG5
    MOVF _neoPixelG5 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR5
    MOVF _neoPixelR5 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB5
    MOVF _neoPixelB5 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG6
    MOVF _neoPixelG6 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR6
    MOVF _neoPixelR6 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB6
    MOVF _neoPixelB6 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG7
    MOVF _neoPixelG7 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR7
    MOVF _neoPixelR7 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB7
    MOVF _neoPixelB7 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG8
    MOVF _neoPixelG8 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR8
    MOVF _neoPixelR8 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB8
    MOVF _neoPixelB8 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG9
    MOVF _neoPixelG9 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR9
    MOVF _neoPixelR9 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB9
    MOVF _neoPixelB9 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG10
    MOVF _neoPixelG10 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR10
    MOVF _neoPixelR10 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB10
    MOVF _neoPixelB10 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG11
    MOVF _neoPixelG11 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR11
    MOVF _neoPixelR11 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB11
    MOVF _neoPixelB11 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG12
    MOVF _neoPixelG12 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR12
    MOVF _neoPixelR12 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB12
    MOVF _neoPixelB12 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG13
    MOVF _neoPixelG13 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR13
    MOVF _neoPixelR13 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB13
    MOVF _neoPixelB13 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG14
    MOVF _neoPixelG14 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR14
    MOVF _neoPixelR14 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB14
    MOVF _neoPixelB14 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG15
    MOVF _neoPixelG15 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR15
    MOVF _neoPixelR15 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB15
    MOVF _neoPixelB15 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG16
    MOVF _neoPixelG16 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR16
    MOVF _neoPixelR16 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB16
    MOVF _neoPixelB16 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG17
    MOVF _neoPixelG17 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR17
    MOVF _neoPixelR17 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB17
    MOVF _neoPixelB17 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG18
    MOVF _neoPixelG18 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR18
    MOVF _neoPixelR18 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB18
    MOVF _neoPixelB18 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG19
    MOVF _neoPixelG19 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR19
    MOVF _neoPixelR19 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB19
    MOVF _neoPixelB19 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG20
    MOVF _neoPixelG20 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR20
    MOVF _neoPixelR20 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB20
    MOVF _neoPixelB20 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG21
    MOVF _neoPixelG21 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR21
    MOVF _neoPixelR21 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB21
    MOVF _neoPixelB21 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG22
    MOVF _neoPixelG22 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR22
    MOVF _neoPixelR22 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB22
    MOVF _neoPixelB22 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG23
    MOVF _neoPixelG23 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR23
    MOVF _neoPixelR23 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB23
    MOVF _neoPixelB23 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG24
    MOVF _neoPixelG24 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR24
    MOVF _neoPixelR24 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB24
    MOVF _neoPixelB24 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG25
    MOVF _neoPixelG25 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR25
    MOVF _neoPixelR25 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB25
    MOVF _neoPixelB25 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG26
    MOVF _neoPixelG26 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR26
    MOVF _neoPixelR26 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB26
    MOVF _neoPixelB26 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG27
    MOVF _neoPixelG27 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR27
    MOVF _neoPixelR27 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB27
    MOVF _neoPixelB27 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG28
    MOVF _neoPixelG28 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR28
    MOVF _neoPixelR28 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB28
    MOVF _neoPixelB28 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG29
    MOVF _neoPixelG29 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR29
    MOVF _neoPixelR29 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB29
    MOVF _neoPixelB29 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG30
    MOVF _neoPixelG30 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR30
    MOVF _neoPixelR30 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB30
    MOVF _neoPixelB30 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    
    BANKSEL _neoPixelG31
    MOVF _neoPixelG31 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelR31
    MOVF _neoPixelR31 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE

    BANKSEL _neoPixelB31
    MOVF _neoPixelB31 & 0x07f, W
    BANKSEL _neoPixelRGB
    MOVWF _neoPixelRGB & 0x07f
    CALL SENDBYTE



    
    RETURN
            
#ifdef WS2812B
    
SENDBYTE   

    // 32MHz : 1setp = 125ns
    // code0 : |~3step(req:400ns,375ns)~|_7step(req:850ns,875ns)_|
    // code1 : |~6step(req:800ns,750ns)~|_4step(req:450ns,500ns)_|

    BSF LATA,NEO_PIN
    NOP
    // Bit Test f, Skip if Set <if(r0.b7==0)>
    BTFSS _neoPixelRGB & 0x07f, 7
    BCF LATA,NEO_PIN
    NOP
    // Bit test f, Skip if Clear <if(r0.b7==1)>
    BTFSC _neoPixelRGB & 0x07f, 7
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 6
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 6
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 5
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 5
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 4
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 4
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 3
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 3
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 2
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 2
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 1
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 1
    BCF LATA,NEO_PIN
    NOP
    NOP
    NOP

    BSF LATA,NEO_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 0
    BCF LATA,NEO_PIN
    NOP
    BTFSC _neoPixelRGB & 0x07f, 0
    BCF LATA,NEO_PIN
    // If you can cut 6 steps here, there is no delay, but only 3 steps are cut.
    
    RETURN    

#endif

#ifdef WS2812C
    
SENDBYTE   
    
    // 32MHz : 1setp = 125ns
    // code0 : |~3step(375ns)~|_7step(875ns)_|
    // code1 : |~5step(625ns)~|_5step(625ns)_|

    BSF LATA,WS2812_PIN
    NOP
    // Bit Test f, Skip if Set <if(r0.b7==0)>
    BTFSS BANKMASK(_neoPixelRGB), 7
    BCF LATA,WS2812_PIN
    // Bit test f, Skip if Clear <if(r0.b7==1)>
    BTFSC BANKMASK(_neoPixelRGB), 7
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 6
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 6
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 5
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 5
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 4
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 4
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 3
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 3
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 2
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 2
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 1
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 1
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS BANKMASK(_neoPixelRGB), 0
    BCF LATA,WS2812_PIN
    BTFSC BANKMASK(_neoPixelRGB), 0
    BCF LATA,WS2812_PIN
    // If you can cut 6 steps here, there is no delay, but only 4 steps are cut.
    
    RETURN    
#endif                
                
#ifdef WS2812Cx
    
SENDBYTE   
    
    // 32MHz : 1setp = 125ns
    // code0 : |~3step(375ns)~|_7step(875ns)_|
    // code1 : |~5step(625ns)~|_5step(625ns)_|

    BSF LATA,WS2812_PIN
    NOP
    // Bit Test f, Skip if Set <if(r0.b7==0)>
    BTFSS _neoPixelRGB & 0x07f, 7
    BCF LATA,WS2812_PIN
    // Bit test f, Skip if Clear <if(r0.b7==1)>
    BTFSC _neoPixelRGB & 0x07f, 7
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 6
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 6
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 5
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 5
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 4
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 4
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 3
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 3
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 2
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 2
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 1
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 1
    BCF LATA,WS2812_PIN
    NOP
    NOP
    NOP
    NOP

    BSF LATA,WS2812_PIN
    NOP
    BTFSS _neoPixelRGB & 0x07f, 0
    BCF LATA,WS2812_PIN
    BTFSC _neoPixelRGB & 0x07f, 0
    BCF LATA,WS2812_PIN
    // If you can cut 6 steps here, there is no delay, but only 4 steps are cut.
    
    RETURN    
#endif
            
#endasm
    
    
}

