/**
 * WS2812
 * 
 * Required system clock is 32MHz.
 * 
 * [Configuration required for #asm]
 * XC8 Global Options: C cstandard [C90]
 * 
 * MPLAB X IDE v5.30 with XC8 Ver2.05
 * (c)2020 Futoshi Sumikawa. 2020/03/25
 * (c)2022 Futoshi Sumikawa. 2022/08/01
 */
#ifndef _WS2812_H_
#define _WS2812_H_

/******************************************************************************/
/* WS2812 #define Macros                                                    */
/******************************************************************************/

// ------------------------------
// Target LED
//#define WS2812B
#define WS2812C

// ------------------------------
// Pin number (PORTA)
#define WS2812_PIN 4

#define WS2812_NUMBER_OF_PIXELS 32

/******************************************************************************/
/* WS2812C Function Prototypes                                               */
/******************************************************************************/

extern void WS2812_Initialize(void);
extern void WS2812_VPOKE(uint8_t address, uint8_t data);
extern void WS2812_Revers(void);
extern void WS2812_SetColor0(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor1(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor2(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor3(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor4(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor5(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor6(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor7(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor7(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor8(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor9(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor10(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor11(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor12(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor13(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor14(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor15(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor16(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor17(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor18(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor19(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor20(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor21(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor22(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor23(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor24(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor25(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor26(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor27(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor28(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor29(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor30(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor31(uint8_t r, uint8_t g, uint8_t b);
extern void WS2812_SetColor(uint8_t n, uint24_t color);
extern void WS2812_Display(void);


#endif